import qs from 'qs'
const axios = require('@/common/axios').default
const apiPrefix = '/api-auth'
// 手机号密码方式登录
export function usernameLogin(data) {
    return axios({
        url: apiPrefix + '/usernameLogin',
        method: 'post',
        data: qs.stringify(data)
    })
}
// 刷新token
export function refreshToken(data) {
    return axios({
        url: apiPrefix + '/refreshToken',
        method: 'post',
        data
    })
}

// 发送登录短信验证码
export function sendSms(data) {
    return axios({
        url: apiPrefix + '/code/sendSms',
        method: 'post',
        data: qs.stringify(data)
    })
}

// 校验短信验证码
export function verifySmsCode(data) {
    return axios({
        url: apiPrefix + '/code/verifySmsCode',
        method: 'post',
        data: qs.stringify(data)
    })
}

// 短信验证码的方式登录
export function smsLogin(data) {
    return axios({
        url: apiPrefix + '/smsLogin',
        method: 'post',
        data: qs.stringify(data)
    })
}